zoukankan      html  css  js  c++  java
  • [leetcode]174. Dungeon Game地牢游戏

    The demons had captured the princess (P) and imprisoned her in the bottom-right corner of a dungeon. The dungeon consists of M x N rooms laid out in a 2D grid. Our valiant knight (K) was initially positioned in the top-left room and must fight his way through the dungeon to rescue the princess.

    The knight has an initial health point represented by a positive integer. If at any point his health point drops to 0 or below, he dies immediately.

    Some of the rooms are guarded by demons, so the knight loses health (negative integers) upon entering these rooms; other rooms are either empty (0's) or contain magic orbs that increase the knight's health (positive integers).

    In order to reach the princess as quickly as possible, the knight decides to move only rightward or downward in each step.

    Write a function to determine the knight's minimum initial health so that he is able to rescue the princess.

    For example, given the dungeon below, the initial health of the knight must be at least 7 if he follows the optimal path RIGHT-> RIGHT -> DOWN -> DOWN.

    -2(K)     -3         3
    -5        -10        1
    10        30       -5(P)

    题意:

    骑士(左上角)要救出公主(右下角),只能从起点开始往右或者往下走。每踩一个格子可能失血(或加血)。骑士能活着(至少保持一滴血不死)救出公主的初始血量至少为多少?

    这个题类似64. Minimum Path Sum , 但更为复杂一点的是,从右下角反推左上角,且至少保持一滴血不死。

    思路:

    -2(K)     -3         3
    -5        -10        1
    10        30       -5(P)

    初始化,

    int[][] dp = new int[row][col];   row = grid.length, col = grid[0].length

    dp[row-1][col-1] = max( 1 - grid[row-1][col-1],  1)   若grid[row-1][col-1] 这格是加血,则反推骑士踩这格之前的血量为1(至少保持一滴血不死)即可。

                                                                             若grid[row-1][col-1] 这格是减血,则反推骑士踩这格之前的血量为1 + 减血血量,即 1 - [row-1][col-1] 

    ?     ?    
    ?     ?     
    ?     ?    6

    是否需要预处理最后一个row: dp[row-1][col],因为矩阵中间的dp[row][col]既可能来自下方,也可能来自右方,所以先预处理仅来自右方的每格结果

    是否需要预处理最后一个col:dp[row][col-1],   因为矩阵中间的dp[row][col]既可能来自下方,也可能来自右方,所以先预处理仅来自下方的每格结果

    
    
    

    代码:

     1 class Solution {
     2     public int calculateMinimumHP(int[][] grid) {
     3         int row = grid.length;  
     4         int col = grid[0].length; 
     5         int[][]dp = new int[row][col];
     6         dp[row-1][col-1] = Math.max (1- grid[row-1][col-1], 1) ; 
     7         
     8         for(int i = row-2; i>=0 ; i--){
     9             dp[i][col-1] = Math.max (dp[i+1][col-1] - grid[i][col-1] , 1) ;
    10         }
    11         for(int j = col-2; j>=0 ; j--){
    12             dp[row-1][j] = Math.max (dp[row-1][j+1] - grid[row-1][j] , 1) ;
    13         }
    14         
    15         for(int i = row-2; i>=0 ; i--){
    16             for(int j = col-2; j>=0 ; j--){
    17                 int down = Math.max (dp[i+1][j] - grid[i][j] , 1) ; 
    18                 int right = Math.max(dp[i][j+1] - grid[i][j], 1);
    19                 dp[i][j] = Math.min(down, right);
    20             }
    21         } 
    22       return dp[0][0];  
    23     }
    24 }
  • 相关阅读:
    生成随机串码并保存到Excel中
    制作100份word表
    抓取网页图片-以本地IIS网页为实践对象
    使用xlsxwriter 创建图表chart
    照片查看器2.0
    编程注意事项-记踩过的坑
    STC12C5A60S2的定时器模式16位的时候没有自动重载功能
    Keil C51 一个警告 '=': pointer: different mspace
    RT-Thread 使用笔记二
    Keil-C51读取ROM数据
  • 原文地址:https://www.cnblogs.com/liuliu5151/p/9059166.html
Copyright © 2011-2022 走看看